//file handling for month data and day data files


//write a single integer to a file: example appendInt(SPIFFS, fileName, data);
//note file must already be opened for writing

void appendInt(fs::FS &fs, const char * path, int iData) {  //add 6 min value to file
  File file = fs.open(path, FILE_APPEND);
  if (!file) {
    Serial.println("appendInt: - failed to open file to append data");
    return;
  }
  char dBuffer[10]; //integer range is -32768 ie 6 digits so allow plenty space
  snprintf(dBuffer, sizeof(dBuffer), " %i", iData); //leading whitespace is ignored by atoi
  if (file.println(dBuffer)) {   // makes character string end with a "\n"
    //Serial.printf("appendInt: 6 min count = %i saved to dayData.log file\n", iData);
  } else {
    Serial.println("File write failed");
  }
  file.close();
}

//read back and accumulate 6min values over whole day
int gatherDay(fs::FS &fs, const char * path) {
  File dayFile = fs.open(path);
  if (!dayFile) {
    Serial.println("Failed to open file for reading");
    return (0);
  }
  else {
    //Serial.println("gatherDay: file opened for reading back data");
  }
  int dayTotalW = 0;
  //scan the file 1 line at a time
  while (dayFile.available()) {
    char iBuffer[10]; //integer range is -32768 ie 6 chars
    //read 1 line of data
    int x = dayFile.readBytesUntil('\n', iBuffer, sizeof(iBuffer) - 1);
    iBuffer[x] = 0; //ensure char array is null terminated for atoi
    int rData = atoi (iBuffer);
    //Serial.printf(": rData is %i", rData);
    dayTotalW += rData;
  }
  Serial.printf(": dayTotal is %i\n", dayTotalW);
  dayFile.close();
  return (dayTotalW);
}

//from SPIFFS_Test example

void writeFile(fs::FS &fs, const char * path, const char * message) {
  File file = fs.open(path, FILE_WRITE);
  if (!file) {
    Serial.println("writeFile: - failed to open file for writing");
    return;
  }
  if (file.print(message)) {
  } else {
    Serial.println("writeFile - write failed");
  }
  file.close();
}

void appendFile(fs::FS &fs, const char * path, const char * message) {
  File file = fs.open(path, FILE_APPEND);
  if (!file) {
    Serial.println("appendFile: - failed to open file for appending");
    return;
  }
  if (file.print(message)) {
  } else {
    Serial.println("appendFile: - append failed");
  }
  file.close();
}

void deleteFile(fs::FS &fs, const char * path){
    Serial.printf("Deleting file: %s\r\n", path);
    if(fs.remove(path)){
        Serial.println("- file deleted");
    } else {
        Serial.println("- delete failed");
    }
}
